(function() {

    var QWeb = openerp.web.qweb;
    openerp.widgetInstance = null;
    openerp.PosButtons = {};

    openerp.PosButtons = openerp.Widget.extend({
        template: 'pos_buttons.PosButtonsWidget',
        row_id_select: undefined,
        
        init: function (parent) {
            this._super(parent);
        },
        
        start: function () {
            var self = this;
            var modal_button = this.$el.find('.add-modal');
            modal_button.click(function() {
                self.fectchModal();
            });
        },
        
        updateId: function(id) {
            var self = this;
            self.id = id;
        },
        
        removeModal: function() {
            $('.pos-modal ').remove();
            $('.modal-backdrop').remove();
        },
        
        fectchModal: function() {
            var self = this;
            self.showModal();
        },

        showModal: function() {
            var self = this;
            var defer =$.Deferred();
            var results = true;

            var modal = QWeb.render('PosModal');
            $('.openerp_webclient_container').after(modal);
            $('.pos-modal').modal();

            $('.sale').click(function(){
                
                self.do_action({
                    
                    type: 'ir.actions.client',
                    tag: "eiru_pos.action_launch",
                    target: 'current',
                    params: {'mode': 'sale'},
                    context: self.session.user_context,

                });
                self.removeModal();
            });
            $('.budget').click(function(){
                
                self.do_action({
                    
                    type: 'ir.actions.client',
                    tag: "eiru_pos.action_launch",
                    target: 'current',
                    params: {'mode': 'budget'},
                    context: self.session.user_context,

                });
                self.removeModal();
            });

            $('.pos-modal').on('hidden.bs.modal', function (e) {
                results = false;
                defer.resolve(results);
                self.removeModal(e);
            });

            return defer;
        },
    });

    if(openerp.web && openerp.web.ListView){
        openerp.web.ListView.include({
            do_show: function(record) {
                this._super.apply(this, arguments);
                if (this.model != 'account.invoice' || this.dataset.context.default_type !== 'out_invoice') return
                openerp.parentInstance = this;
                if (openerp.widgetInstance) {
                    openerp.widgetInstance.updateId(record.id);
                }
                if (this.$el.find('.pos-button').length !== 0 )
                    return;
                openerp.widgetInstance = new openerp.PosButtons(this);
                var elemento = $('.oe_view_manager_buttons');
                elemento = elemento.find('.oe_list_buttons');
                openerp.widgetInstance.appendTo(elemento);
                openerp.widgetInstance.updateId(record.id);
            }
        })
    }

})();
